	import * as THREE from 'three';


	// Vacuum rack
	export function rv(width=800, height=2500, depth=800) {
		const rv_rackObject = new THREE.Object3D();
		const pspump_rackObject = new THREE.Object3D();
		
		const materialGreyDark= new THREE.MeshLambertMaterial({color: 0x9d9d9d});
		const materialGreyMedium= new THREE.MeshLambertMaterial({color: 0x636363});
		const materialVeryGreyDark= new THREE.MeshLambertMaterial({color: 0x242424});
		const silvermaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const greenmaterial = new THREE.MeshLambertMaterial({color: 0x17fc03});
		const whitematerial = new THREE.MeshLambertMaterial({color: 0xffffff});
		const bluematerial = new THREE.MeshLambertMaterial({color: 0x0053d9});
		const softbluematerial = new THREE.MeshLambertMaterial({color: 0x2b7cff});
		const screenmaterial = new THREE.MeshLambertMaterial({color: 0xdeebff});
		const target = new THREE.MeshLambertMaterial({color: 0xfbe928});
		
		// rack
		const rrgeometry = new THREE.BoxGeometry(width, height, depth);
		const rrmesh = new THREE.Mesh(rrgeometry, softbluematerial);
		rrmesh.position.set( 0, 0 , 0);
		rv_rackObject.add(rrmesh);		
		
		//front yellow tag
		const Ftarget = new THREE.BoxGeometry(2, 90, 600);
		const Ftargetmesh = new THREE.Mesh(Ftarget, target);
		Ftargetmesh.position.set( -451, 1200 , -5);
		rv_rackObject.add(Ftargetmesh);		
		//Rear yellow tag
		const Rtarget = new THREE.BoxGeometry(2, 90, 600);
		const Rtargetmesh = new THREE.Mesh(Rtarget, target);
		Rtargetmesh.position.set( 401, 1200 , -5);
		rv_rackObject.add(Rtargetmesh);				
		
		//edge lle	
		const llegeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const llemesh = new THREE.Mesh(llegeometry, bluematerial);
		llemesh.position.set( -425, 0 , -365);
		rv_rackObject.add(llemesh);
		
		//edge lre		
		const lregeometry = new THREE.BoxGeometry(width-750, height, depth-750);
		const lremesh = new THREE.Mesh(lregeometry, bluematerial);
		lremesh.position.set( -425, 0 , 380);
		rv_rackObject.add(lremesh);		

		//edge lue		
		const luegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const luemesh = new THREE.Mesh(luegeometry, bluematerial);
		luemesh.position.set( -425, 1225 , 3);
		rv_rackObject.add(luemesh);		

		//edge lde		
		const ldegeometry = new THREE.BoxGeometry(width-750, height-2450, depth-50);
		const ldemesh = new THREE.Mesh(ldegeometry, bluematerial);
		ldemesh.position.set( -425, -1230 , 3);
		rv_rackObject.add(ldemesh);				
		//silverbase		
		const drawer1geometry = new THREE.BoxGeometry(10, 2450, 750);
		const drawer1geometrymesh = new THREE.Mesh(drawer1geometry, silvermaterial);
		drawer1geometrymesh.position.set( -400, 0 , -10);
		rv_rackObject.add(drawer1geometrymesh);
		
		//base PS ionic Pump
		const baseionicpump = new THREE.BoxGeometry(10, 250, 300);
		const baseionicpumpmesh = new THREE.Mesh(baseionicpump, whitematerial);
		baseionicpumpmesh.position.set( -401, 900 , -150);
		pspump_rackObject.add(baseionicpumpmesh);		

		//sceen PS ionic Pump
		const screenionicpump = new THREE.BoxGeometry(10, 60, 180);
		const screenionicpumpmesh = new THREE.Mesh(screenionicpump, screenmaterial);
		screenionicpumpmesh.position.set( -402, 950 , -150);
		pspump_rackObject.add(screenionicpumpmesh);			
		
		//button ON OFF PS ionic Pump
		const buttonionicpump = new THREE.BoxGeometry(10, 50, 30);
		const buttonionicpumpmesh = new THREE.Mesh(buttonionicpump, materialVeryGreyDark);
		buttonionicpumpmesh.position.set( -402, 830 , -250);
		pspump_rackObject.add(buttonionicpumpmesh);	
		
		//button ON Details 
		const I = new THREE.BoxGeometry(3, 12, 3);
		const IMesh = new THREE.Mesh(I, whitematerial);
		IMesh.position.set( -407, 844 , -250);
		pspump_rackObject.add(IMesh);	
		
		//button OFF Details 
		const OI1 = new THREE.CylinderGeometry(8, 8, 2, 15);
		const OI1Mesh = new THREE.Mesh(OI1, whitematerial);
		OI1Mesh.rotateX(Math.PI * 0.5);
		OI1Mesh.rotateY(Math.PI * 1);
		OI1Mesh.rotateZ(Math.PI * 0.5);
		OI1Mesh.position.set( -407, 817 , -250);		
		pspump_rackObject.add(OI1Mesh);		

		//button OFF Details 2
		const OI2 = new THREE.CylinderGeometry(6, 6, 2, 15);
		const OI2Mesh = new THREE.Mesh(OI2, materialVeryGreyDark);
		OI2Mesh.rotateX(Math.PI * 0.5);
		OI2Mesh.rotateY(Math.PI * 1);
		OI2Mesh.rotateZ(Math.PI * 0.5);
		OI2Mesh.position.set( -408, 817 , -250);		
		pspump_rackObject.add(OI2Mesh);	
		
		//border up
		const borderup = new THREE.BoxGeometry(10, 2, 260);
		const borderupmesh = new THREE.Mesh(borderup, bluematerial);
		borderupmesh.position.set( -402, 1000 , -150);
		pspump_rackObject.add(borderupmesh);	
		
		//border mid
		const bordermid = new THREE.BoxGeometry(10, 2, 260);
		const bordermidmesh = new THREE.Mesh(bordermid, bluematerial);
		bordermidmesh.position.set( -402, 900 , -150);
		pspump_rackObject.add(bordermidmesh);
		
		//border left
		const borderleft = new THREE.BoxGeometry(10, 100, 2);
		const borderleftmesh = new THREE.Mesh(borderleft, bluematerial);
		borderleftmesh.position.set( -402, 950 , -280);
		pspump_rackObject.add(borderleftmesh);	
		
		//border right
		const borderright = new THREE.BoxGeometry(10, 100, 2);
		const borderrightmesh = new THREE.Mesh(borderright, bluematerial);
		borderrightmesh.position.set( -402, 950 , -20);
		pspump_rackObject.add(borderrightmesh);		
		
		//button1  PS ionic Pump
		const button1ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button1ionicpumpmesh = new THREE.Mesh(button1ionicpump, materialGreyDark);
		button1ionicpumpmesh.position.set( -402, 830 , -200);
		pspump_rackObject.add(button1ionicpumpmesh);			
		
		//button2 up  PS ionic Pump
		const button2ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button2ionicpumpmesh = new THREE.Mesh(button2ionicpump, materialGreyDark);
		button2ionicpumpmesh.position.set( -402, 860 , -160);
		pspump_rackObject.add(button2ionicpumpmesh);
		
		//button3 up  PS ionic Pump
		const button3ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button3ionicpumpmesh = new THREE.Mesh(button3ionicpump, materialGreyDark);
		button3ionicpumpmesh.position.set( -402, 860 , -120);
		pspump_rackObject.add(button3ionicpumpmesh);
		
		//button4 up  PS ionic Pump
		const button4ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button4ionicpumpmesh = new THREE.Mesh(button4ionicpump, materialGreyDark);
		button4ionicpumpmesh.position.set( -402, 860 , -80);
		pspump_rackObject.add(button4ionicpumpmesh);
		
		//button5 up  PS ionic Pump
		const button5ionicpump = new THREE.BoxGeometry(10, 30, 30);
		const button5ionicpumpmesh = new THREE.Mesh(button5ionicpump, materialGreyDark);
		button5ionicpumpmesh.position.set( -402, 860 , -40);
		pspump_rackObject.add(button5ionicpumpmesh);	

		rv_rackObject.add(pspump_rackObject);
		//CLONE PS PUMP

		const pump2 = pspump_rackObject.clone();
		pump2.position.set( 0, 0 , 310);
		rv_rackObject.add(pump2);
		
		const pump3 = pspump_rackObject.clone();
		pump3.position.set( 0, -260 , 0);
		rv_rackObject.add(pump3);	
		
		const pump4 = pspump_rackObject.clone();
		pump4.position.set( 0, -260 , 310);
		rv_rackObject.add(pump4);
		
		const pump5 = pspump_rackObject.clone();
		pump5.position.set( 0, -520 , 0);
		rv_rackObject.add(pump5);
		
		const pump6 = pspump_rackObject.clone();
		pump6.position.set( 0, -520 , 310);
		rv_rackObject.add(pump6);
		
	
		return rv_rackObject;
	}
